<?php
/* 
 * This file is used to write common functions body and logic
 */

 function logException($e) {
     echo $message = "Exception: " . $e->getMessage();
     if (WP_DEBUG === true) {
         if (is_array($message) || is_object($message)) {
             error_log(print_r($message, true));
         } else {
             error_log($message);
         }
     }
 }


//Used to get the User ID using code
function getMembershipDetails($accessToken) {

    try {

        //get Membership API
        $tenantId = get_option( 'rhythm_tenant_id');
        $eventId = get_option( 'rhythm_event_id');
        
        //form curlopt URL
        $curlopt_url = "https://partners.api.rhythmsoftware.com/fusionspan/" . $tenantId . "/details";

        if(isset($eventId) && trim($eventId) !== ''){
            $curlopt_url = $curlopt_url . "/" . $eventId;
        }
        
        $curl = curl_init();

        curl_setopt_array($curl, array( 
            CURLOPT_URL => $curlopt_url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => array(
              "accept: application/json",
              "cache-control: no-cache",
              "authorization: Bearer $accessToken"
            ),
        ));
        
        $response = curl_exec($curl);
        $statusCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);

        if($statusCode != 200){
            throw new \Exception("Rhythm API returned status " . $statusCode);
        }

        $response = json_decode($response);
        
        return $response;
        
    } catch (Exception $e) {
        logException($e);
    }
}

/*
 * Author: Fusionspan
 * Description: Used to gather user roles based on security ID
 * 
 */
function getRoles($secPolicies) {
    try {
        
        $roles = [];
        if(!empty($secPolicies)){
            
            foreach($secPolicies as $v){
                $roles[] = $v->security_policy_id;
            }
        }
        
        return $roles;
        
    } catch (Exception $e) {
        logException($e);
    }
}
